Ruby: ext/digest/sha2/sha2.c File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Macros | Typedefs | Functions
sha2.c File Reference
`#include "../defs.h"`
`#include <string.h>`
`#include <assert.h>`
`#include "sha2.h"`

Go to the source code of this file.

## Macros
#define | SHA256_SHORT_BLOCK_LENGTH (SHA256_BLOCK_LENGTH - 8)
#define | SHA384_SHORT_BLOCK_LENGTH (SHA384_BLOCK_LENGTH - 16)
#define | SHA512_SHORT_BLOCK_LENGTH (SHA512_BLOCK_LENGTH - 16)
#define | ULL(number) number##ULL
#define | REVERSE32(w, x)
#define | REVERSE64(w, x)
#define | ADDINC128(w, n)
#define | SHA2_USE_MEMSET_MEMCPY 1
#define | MEMSET_BZERO(p, l) memset((p), 0, (l))
#define | MEMCPY_BCOPY(d, s, l) memcpy((d), (s), (l))
#define | R(b, x) ((x) >> (b))
#define | S32(b, x) (((x) >> (b)) | ((x) << (32 - (b))))
#define | S64(b, x) (((x) >> (b)) | ((x) << (64 - (b))))
#define | Ch(x, y, z) (((x) & (y)) ^ ((~(x)) & (z)))
#define | Maj(x, y, z) (((x) & (y)) ^ ((x) & (z)) ^ ((y) & (z)))
#define | Sigma0_256(x) (S32(2, (x)) ^ S32(13, (x)) ^ S32(22, (x)))
#define | Sigma1_256(x) (S32(6, (x)) ^ S32(11, (x)) ^ S32(25, (x)))
#define | sigma0_256(x) (S32(7, (x)) ^ S32(18, (x)) ^ R(3 , (x)))
#define | sigma1_256(x) (S32(17, (x)) ^ S32(19, (x)) ^ R(10, (x)))
#define | Sigma0_512(x) (S64(28, (x)) ^ S64(34, (x)) ^ S64(39, (x)))
#define | Sigma1_512(x) (S64(14, (x)) ^ S64(18, (x)) ^ S64(41, (x)))
#define | sigma0_512(x) (S64( 1, (x)) ^ S64( 8, (x)) ^ R( 7, (x)))
#define | sigma1_512(x) (S64(19, (x)) ^ S64(61, (x)) ^ R( 6, (x)))

## Typedefs
typedef uint8_t | sha2_byte
typedef uint32_t | sha2_word32
typedef uint64_t | sha2_word64

## Functions
void | SHA512_Last (SHA512_CTX *)
void | SHA256_Transform (SHA256_CTX *, const sha2_word32 *)
void | SHA512_Transform (SHA512_CTX *, const sha2_word64 *)
int | SHA256_Init (SHA256_CTX *context)
void | SHA256_Update (SHA256_CTX *context, const sha2_byte *data, size_t len)
int | SHA256_Final (sha2_byte digest[], SHA256_CTX *context)
char * | SHA256_End (SHA256_CTX *context, char buffer[])
char * | SHA256_Data (const sha2_byte *data, size_t len, char digest[SHA256_DIGEST_STRING_LENGTH])
int | SHA512_Init (SHA512_CTX *context)
void | SHA512_Update (SHA512_CTX *context, const sha2_byte *data, size_t len)
int | SHA512_Final (sha2_byte digest[], SHA512_CTX *context)
char * | SHA512_End (SHA512_CTX *context, char buffer[])
char * | SHA512_Data (const sha2_byte *data, size_t len, char digest[SHA512_DIGEST_STRING_LENGTH])
int | SHA384_Init (SHA384_CTX *context)
void | SHA384_Update (SHA384_CTX *context, const sha2_byte *data, size_t len)
int | SHA384_Final (sha2_byte digest[], SHA384_CTX *context)
char * | SHA384_End (SHA384_CTX *context, char buffer[])
char * | SHA384_Data (const sha2_byte *data, size_t len, char digest[SHA384_DIGEST_STRING_LENGTH])

## Macro Definition Documentation

## ◆ ADDINC128

#define ADDINC128 | ( |  | w,
|  |  | n
| ) |  |

Value:
{ \
(w)[0] += (sha2_word64)(n); \
if ((w)[0] < (n)) { \
(w)[1]++; \
} \
}
sha2_word64
uint64_t sha2_word64
Definition: sha2.c:113

Definition at line 158 of file sha2.c.

## ◆ Ch

#define Ch | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | (((x) & (y)) ^ ((~(x)) & (z)))

Definition at line 210 of file sha2.c.

## ◆ Maj

#define Maj | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | (((x) & (y)) ^ ((x) & (z)) ^ ((y) & (z)))

Definition at line 211 of file sha2.c.

## ◆ MEMCPY_BCOPY

#define MEMCPY_BCOPY | ( |  | d,
|  |  | s,
|  |  | l
| ) |  | memcpy((d), (s), (l))

Definition at line 185 of file sha2.c.

## ◆ MEMSET_BZERO

#define MEMSET_BZERO | ( |  | p,
|  |  | l
| ) |  | memset((p), 0, (l))

Definition at line 184 of file sha2.c.

## ◆ R

#define R | ( |  | b,
|  |  | x
| ) |  | ((x) >> (b))

Definition at line 203 of file sha2.c.

## ◆ REVERSE32

#define REVERSE32 | ( |  | w,
|  |  | x
| ) |  |

Value:
{ \
sha2_word32 tmp = (w); \
tmp = (tmp >> 16) | (tmp << 16); \
(x) = ((tmp & (sha2_word32)0xff00ff00UL) >> 8) | ((tmp & (sha2_word32)0x00ff00ffUL) << 8); \
}
sha2_word32
uint32_t sha2_word32
Definition: sha2.c:112

Definition at line 138 of file sha2.c.

## ◆ REVERSE64

#define REVERSE64 | ( |  | w,
|  |  | x
| ) |  |

Value:
{ \
sha2_word64 tmp = (w); \
tmp = (tmp >> 32) | (tmp << 32); \
tmp = ((tmp & ULL(0xff00ff00ff00ff00)) >> 8) | \
((tmp & ULL(0x00ff00ff00ff00ff)) << 8); \
(x) = ((tmp & ULL(0xffff0000ffff0000)) >> 16) | \
((tmp & ULL(0x0000ffff0000ffff)) << 16); \
}
ULL
#define ULL(number)
Definition: sha2.c:132

Definition at line 143 of file sha2.c.

## ◆ S32

#define S32 | ( |  | b,
|  |  | x
| ) |  | (((x) >> (b)) | ((x) << (32 - (b))))

Definition at line 205 of file sha2.c.

## ◆ S64

#define S64 | ( |  | b,
|  |  | x
| ) |  | (((x) >> (b)) | ((x) << (64 - (b))))

Definition at line 207 of file sha2.c.

## ◆ SHA256_SHORT_BLOCK_LENGTH

#define SHA256_SHORT_BLOCK_LENGTH (SHA256_BLOCK_LENGTH - 8)

Definition at line 126 of file sha2.c.

## ◆ SHA2_USE_MEMSET_MEMCPY

#define SHA2_USE_MEMSET_MEMCPY 1

Definition at line 176 of file sha2.c.

## ◆ SHA384_SHORT_BLOCK_LENGTH

#define SHA384_SHORT_BLOCK_LENGTH (SHA384_BLOCK_LENGTH - 16)

Definition at line 127 of file sha2.c.

## ◆ SHA512_SHORT_BLOCK_LENGTH

#define SHA512_SHORT_BLOCK_LENGTH (SHA512_BLOCK_LENGTH - 16)

Definition at line 128 of file sha2.c.

## ◆ Sigma0_256

#define Sigma0_256 | ( |  | x | ) | (S32(2, (x)) ^ S32(13, (x)) ^ S32(22, (x)))

Definition at line 214 of file sha2.c.

## ◆ sigma0_256

#define sigma0_256 | ( |  | x | ) | (S32(7, (x)) ^ S32(18, (x)) ^ R(3 , (x)))

Definition at line 216 of file sha2.c.

## ◆ Sigma0_512

#define Sigma0_512 | ( |  | x | ) | (S64(28, (x)) ^ S64(34, (x)) ^ S64(39, (x)))

Definition at line 220 of file sha2.c.

## ◆ sigma0_512

#define sigma0_512 | ( |  | x | ) | (S64( 1, (x)) ^ S64( 8, (x)) ^ R( 7, (x)))

Definition at line 222 of file sha2.c.

## ◆ Sigma1_256

#define Sigma1_256 | ( |  | x | ) | (S32(6, (x)) ^ S32(11, (x)) ^ S32(25, (x)))

Definition at line 215 of file sha2.c.

## ◆ sigma1_256

#define sigma1_256 | ( |  | x | ) | (S32(17, (x)) ^ S32(19, (x)) ^ R(10, (x)))

Definition at line 217 of file sha2.c.

## ◆ Sigma1_512

#define Sigma1_512 | ( |  | x | ) | (S64(14, (x)) ^ S64(18, (x)) ^ S64(41, (x)))

Definition at line 221 of file sha2.c.

## ◆ sigma1_512

#define sigma1_512 | ( |  | x | ) | (S64(19, (x)) ^ S64(61, (x)) ^ R( 6, (x)))

Definition at line 223 of file sha2.c.

## ◆ ULL

#define ULL | ( |  | number | ) | number##ULL

Definition at line 132 of file sha2.c.

## Typedef Documentation

## ◆ sha2_byte

typedef uint8_t sha2_byte

Definition at line 111 of file sha2.c.

## ◆ sha2_word32

typedef uint32_t sha2_word32

Definition at line 112 of file sha2.c.

## ◆ sha2_word64

typedef uint64_t sha2_word64

Definition at line 113 of file sha2.c.

## Function Documentation

## ◆ SHA256_Data()

char * SHA256_Data | ( | const sha2_byte * | data,
|  | size_t | len,
|  | char | digest[SHA256_DIGEST_STRING_LENGTH]
| ) |  |

Definition at line 665 of file sha2.c.

References len, SHA256_End(), SHA256_Init(), and SHA256_Update.

## ◆ SHA256_End()

char * SHA256_End | ( | SHA256_CTX * | context,
|  | char | buffer[]
| ) |  |

Definition at line 643 of file sha2.c.

References assert, MEMSET_BZERO, SHA256_DIGEST_LENGTH, and SHA256_Final().

Referenced by SHA256_Data().

## ◆ SHA256_Final()

int SHA256_Final | ( | sha2_byte | digest[],
|  | SHA256_CTX * | context
| ) |  |

Definition at line 578 of file sha2.c.

References assert, _SHA256_CTX::bitcount, _SHA256_CTX::buffer, int(), MEMCPY_BCOPY, MEMSET_BZERO, REVERSE32, REVERSE64, SHA256_BLOCK_LENGTH, SHA256_DIGEST_LENGTH, SHA256_SHORT_BLOCK_LENGTH, SHA256_Transform(), and _SHA256_CTX::state.

Referenced by SHA256_End().

## ◆ SHA256_Init()

int SHA256_Init | ( | SHA256_CTX * | context | ) |

Definition at line 344 of file sha2.c.

References _SHA256_CTX::bitcount, _SHA256_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, SHA256_BLOCK_LENGTH, SHA256_DIGEST_LENGTH, and _SHA256_CTX::state.

Referenced by SHA256_Data().

## ◆ SHA256_Transform()

void SHA256_Transform | ( | SHA256_CTX * | context,
|  | const sha2_word32 * | data
| ) |  |

Definition at line 449 of file sha2.c.

References _SHA256_CTX::buffer, BYTE_ORDER, Ch, f, g, LITTLE_ENDIAN, Maj, REVERSE32, Sigma0_256, Sigma1_256, _SHA256_CTX::state, T1, and T2.

Referenced by SHA256_Final(), and SHA256_Update().

## ◆ SHA256_Update()

void SHA256_Update | ( | SHA256_CTX * | context,
|  | const sha2_byte * | data,
|  | size_t | len
| ) |  |

Definition at line 529 of file sha2.c.

References assert, _SHA256_CTX::bitcount, _SHA256_CTX::buffer, int(), len, MEMCPY_BCOPY, SHA256_BLOCK_LENGTH, and SHA256_Transform().

## ◆ SHA384_Data()

char * SHA384_Data | ( | const sha2_byte * | data,
|  | size_t | len,
|  | char | digest[SHA384_DIGEST_STRING_LENGTH]
| ) |  |

Definition at line 1074 of file sha2.c.

References len, SHA384_End(), SHA384_Init(), and SHA384_Update.

## ◆ SHA384_End()

char * SHA384_End | ( | SHA384_CTX * | context,
|  | char | buffer[]
| ) |  |

Definition at line 1052 of file sha2.c.

References assert, MEMSET_BZERO, SHA384_DIGEST_LENGTH, and SHA384_Final().

Referenced by SHA384_Data().

## ◆ SHA384_Final()

int SHA384_Final | ( | sha2_byte | digest[],
|  | SHA384_CTX * | context
| ) |  |

Definition at line 1022 of file sha2.c.

References assert, MEMCPY_BCOPY, MEMSET_BZERO, REVERSE64, SHA384_DIGEST_LENGTH, SHA512_Last(), and _SHA512_CTX::state.

Referenced by SHA384_End().

## ◆ SHA384_Init()

int SHA384_Init | ( | SHA384_CTX * | context | ) |

Definition at line 1008 of file sha2.c.

References _SHA512_CTX::bitcount, _SHA512_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, SHA384_BLOCK_LENGTH, SHA512_DIGEST_LENGTH, and _SHA512_CTX::state.

Referenced by SHA384_Data().

## ◆ SHA384_Update()

void SHA384_Update | ( | SHA384_CTX * | context,
|  | const sha2_byte * | data,
|  | size_t | len
| ) |  |

Definition at line 1018 of file sha2.c.

References len, and SHA512_Update.

## ◆ SHA512_Data()

char * SHA512_Data | ( | const sha2_byte * | data,
|  | size_t | len,
|  | char | digest[SHA512_DIGEST_STRING_LENGTH]
| ) |  |

Definition at line 998 of file sha2.c.

References len, SHA512_End(), SHA512_Init(), and SHA512_Update.

## ◆ SHA512_End()

char * SHA512_End | ( | SHA512_CTX * | context,
|  | char | buffer[]
| ) |  |

Definition at line 976 of file sha2.c.

References assert, MEMSET_BZERO, SHA512_DIGEST_LENGTH, and SHA512_Final().

Referenced by SHA512_Data().

## ◆ SHA512_Final()

int SHA512_Final | ( | sha2_byte | digest[],
|  | SHA512_CTX * | context
| ) |  |

Definition at line 946 of file sha2.c.

References assert, MEMCPY_BCOPY, MEMSET_BZERO, REVERSE64, SHA512_DIGEST_LENGTH, SHA512_Last(), and _SHA512_CTX::state.

Referenced by SHA512_End().

## ◆ SHA512_Init()

int SHA512_Init | ( | SHA512_CTX * | context | ) |

Definition at line 675 of file sha2.c.

References _SHA512_CTX::bitcount, _SHA512_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, SHA512_BLOCK_LENGTH, SHA512_DIGEST_LENGTH, and _SHA512_CTX::state.

Referenced by SHA512_Data().

## ◆ SHA512_Last()

void SHA512_Last | ( | SHA512_CTX * | context | ) |

Definition at line 903 of file sha2.c.

References _SHA512_CTX::bitcount, _SHA512_CTX::buffer, int(), MEMCPY_BCOPY, MEMSET_BZERO, REVERSE64, SHA512_BLOCK_LENGTH, SHA512_SHORT_BLOCK_LENGTH, and SHA512_Transform().

Referenced by SHA384_Final(), and SHA512_Final().

## ◆ SHA512_Transform()

void SHA512_Transform | ( | SHA512_CTX * | context,
|  | const sha2_word64 * | data
| ) |  |

Definition at line 776 of file sha2.c.

References _SHA512_CTX::buffer, BYTE_ORDER, Ch, f, g, LITTLE_ENDIAN, Maj, REVERSE64, Sigma0_512, Sigma1_512, _SHA512_CTX::state, T1, and T2.

Referenced by SHA512_Last(), and SHA512_Update().

## ◆ SHA512_Update()

void SHA512_Update | ( | SHA512_CTX * | context,
|  | const sha2_byte * | data,
|  | size_t | len
| ) |  |

Definition at line 854 of file sha2.c.

References ADDINC128, assert, _SHA512_CTX::bitcount, _SHA512_CTX::buffer, int(), len, MEMCPY_BCOPY, SHA512_BLOCK_LENGTH, and SHA512_Transform().